#!/usr/bin/perl


#
#  create_cached_version.pl
#  creates cached version of weather weboage
#
#  Part of Loxberry
#
# (c) Michael Schlenstedt. All rights reserved.
#
#  Latest change: 19/11/15 12:06:00 Wed
#

#use strict;
#use warnings;

# Version of this script
my $version = "2.0.0";

# Modules
use LWP::UserAgent;
use Getopt::Long;

# Read settings
require "../data/settings.dat";

# Commandline options
my $verbose = '';
my $help = '';

GetOptions ('verbose' => \$verbose,
	        'quiet'   => sub { $verbose = 0 });

# Starting...
my $logmessage = "\nStarting $0 Version $version\n";
&log;

# Get webopage
$logmessage = "Fetching Weather Webpage from $showurl\n";
&log;

my $ua = new LWP::UserAgent;
my $res = $ua->get($showurl);
my $content = $res->decoded_content();

# Check status of request
my $urlstatus = $res->status_line;
my $urlstatuscode = substr($urlstatus,0,3);

if ($urlstatuscode ne "200") {
  $errormessage = "Failed to fetch page at $showurl\. Status Code: $urlstatuscode";
  &error;
}

open(F,">$cachedfile") || die "Cannot open $cachedfile";
  flock(F,2) if($flock);
  binmode F, ':encoding(UTF-8)';
  print F $content;
  flock(F,8) if($flock);
close(F);

# Give OK status to client.
$logmessage = "Status: OK. Cached webpage created successfully. Bye.\n\n";
&log;

# Exit
exit;

#
# Subroutinen
#

sub log {

  # Print
  if ($verbose || $error) {print $logmessage;}

  return();
}

# Error Message
sub error {
  $logmessage = "ERROR: $errormessage\n";
  &log;
  exit;
}
